define("de_epages/amazonpayments/checkoutconfirmation", [
  "jquery",
  "ep/ui/form",
  "ep/fn/busy"
], function ($) {
  var basketData = $("#addressBookWidgetDiv").data(),
    BasketId = basketData.basketid,
    ReferenceId = basketData.refid,
    MerchantId = basketData.merchantid;

  function getParameterValue(parameterName) {
    var result = null,
        tmp = [];
    var items = location.search.substr(1).split("&");
    for (var index = 0; index < items.length; index++) {
        tmp = items[index].split("=");
        if (tmp[0] === parameterName) result = decodeURIComponent(tmp[1]);
    }
    return result;
  }

  function injectAmazonWidgets() {
    new OffAmazonPayments.Widgets.AddressBook({
      sellerId: MerchantId,
      amazonOrderReferenceId: ReferenceId,
      displayMode: "Read",
      design: {size: {width: "290px", height: "185px"}},
      onError: function (error) {
        handleError(error.getErrorCode(), "AddressError");
      }
    }).bind("addressBookWidgetDiv");

    new OffAmazonPayments.Widgets.Wallet({
      sellerId: MerchantId,
      amazonOrderReferenceId: ReferenceId,
      displayMode: "Read",
      design: {size: {width: "290px", height: "185px"}},
      onError: function (error) {
        handleError(error.getErrorCode(), "WalletError");
      }
    }).bind("walletWidgetDiv");
  }

  function handleAmazonCallback() {
    if ("Success" === getParameterValue("AuthenticationStatus") && "SaveMultiCheckoutConfirmation" === getParameterValue("ChangeAction")) {
        document.forms["BasketForm"].submit();
    } else {
      injectAmazonWidgets();
      $('#BasketForm').submit(function() {
        ep(this).busy('show');
        onBuyButtonClick();
        return false;
      });
      $(document.body).busy('hide');
    }
  }

  function handleError(errorCode, errorType) {
    window.location.href = "?ViewAction=TriggerAmazonPaymentsError&ObjectID=" + BasketId + "&" + errorType + "=" + errorCode;
  }

  function onBuyButtonClick() {
    new OffAmazonPayments.initConfirmationFlow(MerchantId, ReferenceId, function(confirmationFlow) {
      confirmOrderReference(confirmationFlow);
    });
  }

  function confirmOrderReference(confirmationFlow) {
    $.ajax({
        url: '?ChangeAction=OrderConfirmationAmazonPayment&ObjectID=' + BasketId,
        method: 'POST',
        success: function (data) {
          confirmationFlow.success(); // continue Amazon Pay initConfirmationFlow
        },
        error: function (data) { // called on AJAX error and timeout
          confirmationFlow.error(); // abort Amazon Pay initConfirmationFlow
          $('#BasketForm').busy('hide');
          $('#initConfirmationFlowErrorDiv').show();
        },
      timeout: "9000"
    });
  }

  $(document.body).busy("show");
  handleAmazonCallback();

});